;()  ,  2010

#DEFINE	push8d push d\ push d\ push d\ push d\ push d\ push d\ push d\ push d

PNT		.equ	4C00h
PGT		.equ	4000h
PGThi		.equ	PGT>>8
Graphics	.equ	5000h
GraphicsHi	.equ	Graphics>>8


Col0000	.equ	00000000b	;0
Col0001	.equ	00000000b	;1
Col0010	.equ	01110001b	;2
Col0011	.equ	01110011b	;3
Col0100	.equ	11010010b	;4
Col0101	.equ	11011011b	;5
Col0110	.equ	01010110b	;6
Col0111	.equ	11111010b	;7
Col1000	.equ	01010111b	;8
Col1001	.equ	10011111b	;9
Col1010	.equ	01101110b	;10
Col1011	.equ	10110110b	;11
Col1100	.equ	01101001b	;12
Col1101	.equ	10011110b	;13
Col1110	.equ	10101101b	;14
Col1111	.equ	11111111b	;15
logow		.equ	22
logoh		.equ	15

		.org	100h

		di
		xra	a
		out	10h
		lxi	sp,100h
		lxi	h,0C3F3h
		shld	0
		mov	a,h
		lxi	h,Restart
		shld	2
		sta	38h
		lxi	h,KEYINT
		shld	38h+1

; PNT,      
		lxi	h,PGT
		xra	a
ClsLoop:	mov	m,a
		inx	h
		cmp	h
		jnz	ClsLoop

		call	PalProg
		lxi	sp,100h
		lxi	h,Logo
		lxi	d,0851Fh+6
		call	DrwLogo
		lxi	h,Logo
		lxi	d,0C51Fh+6
		call	DrwLogo

Restart:
		lxi	sp,100h
		mvi	a, 88h
		out	4		; R-Sound 2
		call	GICINI

;		ei
		.include "bomber.asm"

DrwLogo:
		mvi	b,logow
logo2:	push	d
		mvi	c,logoh
logo1:	mov	a,m
		stax	d
		inx	h
		inr	e
		dcr	c
		jnz	logo1
		pop	d
		inr	d
		dcr	b
		jnz	logo2
		ret

KEYINT:
		push	psw
; 
		mvi	a, 8Ah
		out	0
		mvi	a, 0FEh
		out	3
		in	2
		sta	CursorKeys
		mvi	a, 07Fh
		out	3
		in	2
		sta	SpaceKey
;,    
		mvi	a, 88h
		out	0
		mvi	a, 2
		out	1
		mvi	a, 23
		out	3		;
		mvi	a, 00000000b
		out	2		;   
		pop	psw
		ei
		ret

PalProg:
		push	psw
		push	d
		push	h
		di
		mvi	a,0C9h
		sta	38h
		ei
		hlt
; 
		mvi	e, 15
		lxi	h, Palette+15
PaletLoop:
		mov	a, e
		out	2
		mov	a, m
		out	0Ch
		xthl
		xthl
		dcx	h
		dcr	e
		out	0Ch
		jp	PaletLoop
		pop	h
		pop	d
		pop	psw
		mvi	a,0C3h
		sta	38h
		ei
		ret


Palette:	.db Col0000,Col0001,Col0010,Col0011
		.db Col0100,Col0101,Col0110,Col0111
		.db Col1000,Col1001,Col1010,Col1011
		.db Col1100,Col1101,Col1110,Col1111


CursorKeys:	.db 11111111b
SpaceKey:	.db 11111111b

		.include "znagenprerend.asm"

GICINI:
L0090:
		mvi	a,13
		mvi	e,0
AYOFF1:
		call	WRTPSG
		dcr	a
		jp	AYOFF1
		mvi	a,7
		mvi	e,0B8h
		call	WRTPSG
		ret

WRTPSG:
L0093:
		push	psw
		out	15h
		out	06
		mvi	a, 06
		out	05
		xra	a
		out	05
		mov	a, e
		out	14h
		out	06
		mvi	a,04
		out	05
		xra	a
		out	05
		pop	psw
		ret

SNSMAT:
		cpi	8
		jz	SNSMAT8
		mvi	a,0FFh
		ret
SNSMAT8:	
		push	h
		lxi	h,MSXKey
		mvi	m,0FFh
		lda	SpaceKey
		ani	10000000b
		jnz	ChkDwn
SPACE:	mov	a,m
		ani	11111110b
		mov	m,a
ChkDwn:	lda	CursorKeys
		ani	10000000b	;  ,  MSX - 
		jnz	ChkRight
CurDwn:	mov	a,m
		ani	10111111b
		mov	m,a
ChkRight:	lda	CursorKeys
		ani	01000000b	;  ,  MSX - 
		jnz	ChkUp
CurRight:	mov	a,m
		ani	01111111b
		mov	m,a
ChkUp:	lda	CursorKeys
		ani	00100000b	;  ,  MSX - 
		jnz	ChkLeft
CurUp:	mov	a,m
		ani	11011111b
		mov	m,a
ChkLeft:	lda	CursorKeys
		ani	00010000b	;  ,  MSX - 
		jnz	SNSMATout
CurLeft:	mov	a,m
		ani	11101111b
		mov	m,a
SNSMATout:	mov	a,m
		pop	h
		ret
MSXKey:	.db	0FFh

GTSTCK:
L00D5:
		mvi     a, 8
		call    SNSMAT
		rrc
		rrc
		rrc
		rrc
		lxi     h, KeybDir
		ani     00001111b
		mov     e, a
		mvi     d, 0
		dad     d
		mov     a, m
		ret
KeybDir:
		.db    0,   3,   5,   4
		.db    1,   2,   0,   3
		.db    7,   0,   6,   5
		.db    8,   1,   7,   0

GTTRIG:
L00D8:
		mvi     a, 8
		call    SNSMAT
		cma
		ani     1
		rz
		mvi	a,0FFh
		ret

Logo:
		.include "logo.asm"


		.end